#!/bin/sh
# $Id: pkgmake.sh,v 1.10 2002/01/03 10:58:01 mrgoblin Exp $

# This script should be run from the top SAStk/ directory of a CVS checkout.
# e.g. cd ~/projects/SAStk; ./pkgmake.sh

#############################################
#
# SAStk Package Creation Script
#
# For Slackware Linux 8.0
#
#############################################
# SAStk 0.1.3.0
# Copyright (C) 2000 John Jenkins, Doug Hogan, Jeffrey Denton
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
############################################# 

# Check for root
if [ ! "${UID}" = "0" ]; then
/bin/echo "You must be root to run $0 !"
exit
fi

PKG_TMP="/root/SAStk_pkg.$$"
/bin/mkdir -m 0755 "${PKG_TMP}"

# Setup signal handler
handle_sigint() {
    /bin/stty intr ""
    /bin/echo -n "                 WARNING : ctrl+c pressed!"
    /bin/echo -ne " Killing SAStk                         "
    /bin/echo
    # Remove any temporary files and aliases
    if [ -d "${PKG_TMP}" ]; then
        /bin/rm -r "${PKG_TMP}" 
    fi
    /bin/stty intr ^C
    exit 1
}

trap handle_sigint 2

# Set up directory structure

for dir in root \
root/SAStk \
root/SAStk/docs \
install ; do
/bin/mkdir -m 0700 -p "${PKG_TMP}/$dir"
done

for dir in usr \
usr/doc \
usr/doc/SAStk \
usr/local \
usr/local/info ; do 
/bin/mkdir -m 0755 -p "${PKG_TMP}/$dir"
done

# Copy Docs
for file in $(/usr/bin/find ./docs -type f |grep -v CVS) ; do
/bin/cp  "$file" "${PKG_TMP}/root/SAStk/docs"
/bin/cp  "$file" "${PKG_TMP}/usr/doc/SAStk"
done
/bin/cp ./docs/sastk.info "${PKG_TMP}/usr/local/info"
/bin/chmod 0644 ${PKG_TMP}/usr/doc/SAStk/sastk*

# Copy Install notes etc
for file in $(/usr/bin/find . -type f -maxdepth 1) ; do
/bin/cp "$file" "${PKG_TMP}/root/SAStk/"
done

# Copy src files
/bin/cp -R ./src "${PKG_TMP}/root/SAStk/"

# Remove CVS Directories
/usr/bin/find ${PKG_TMP}/root/SAStk/src -type d -name CVS |/usr/bin/xargs /bin/rm -r


# Clear the screen
/usr/bin/clear

# Create doinst.sh
/usr/bin/cat >> "${PKG_TMP}/install/doinst.sh" << EOF
#!/bin/sh
/bin/chmod 0700 /root/SAStk/src/*.sh

/usr/bin/cat << !

The SAStk source files should now be in /root/SAStk/
Please cd to /root/SAStk/ and read the NOTES, README
and INSTALL files.
These documents contain important information and reading
them will help you to better understand the changes that
will be made by SAStk.
You will find additional information in various formats
in /usr/doc/SAStk/

To begin the install please cd to /root/SAStk/src/
and issue the command
./install.sh

This will begin the installation and configuration process.

Thankyou

SAStk Team
!

EOF

cd "${PKG_TMP}"
/sbin/makepkg "SAStk.tgz"

/bin/echo "Package ${PKG_TMP}/SAStk.tgz created"

# EOF

