#!/bin/sh
# $Id: sastk.sh,v 1.32 2001/07/22 01:47:16 zyrnix Exp $

#############################################
#
# SAStk Hardening Script
#
# For Slackware Linux 7.0 - 7.1
#
#############################################
# SAStk 0.1.3.0
# Copyright (C) 2000-2001 John Jenkins, Doug Hogan, Jeffrey Denton
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#############################################

# Setup signal handler
handle_sigint() {
    /bin/stty intr ""
    /bin/echo -n "                 WARNING : ctrl+c pressed!"
    /bin/echo -ne " Killing SAStk                         "
    /bin/echo
    # Remove any temporary files and aliases
    if [ -d /root/.sastk_tmp ]; then
        /bin/rm -r /root/.sastk_tmp   
    fi
    /bin/stty intr ^C
    exit 1
}

trap handle_sigint 2

if [ -f ./scripts/scripts-admin/setup_sastk.sh ]; then
    . ./scripts/scripts-admin/setup_sastk.sh 
else
    /bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "Error" --msgbox \
"Could not find ./scripts/scripts-admin/setup_sastk.sh" 6 70
    exit
fi

if [ -f ./scripts/scripts-admin/start_work.sh ]; then
    . ./scripts/scripts-admin/start_work.sh
else
    /bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "Error" --msgbox \
"Could not find ./scripts/scripts-admin/start_work.sh" 6 70
    exit
fi

for f in `ls scripts/dialogs/*.sh`; do
    answer2=""
    new_answer=""
if [ -n "`sh $f`" ]; then
/bin/dialog --backtitle "Slackware Security ToolKit \
[ http://sourceforge.net/projects/sastk ]" --title "`/bin/sh $f | /usr/bin/grep '^Checking'`" --yesno \
"`/bin/sh $f | /usr/bin/grep -v '^Checking'`" 19 80
    some_answer=$?
    if [ ${some_answer} = 0 ]; then
        new_answer="`/bin/echo "$f" | /bin/cut -f 3 -d/`"
        if [ -f "scripts/scripts-sastk/${new_answer}" ]; then 
            . "scripts/scripts-sastk/${new_answer}"
        else
    /bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "Error" --yesno \
"Could not find ${new_answer} file\n\
Do you want to quit?" 8 60
             if [ $? = 0 ]; then
                exit
             fi
        fi
        # Also need to update scripts-answers in here
    fi
fi
done

if [ -f scripts/scripts-sastk/disable_daemons.sh ]; then
    . scripts/scripts-sastk/disable_daemons.sh
else
    /bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "Error" --msgbox \
"Could not find ./scripts/scripts-sastk/disable_daemons.sh" 6 70
    exit
fi

if [ -f scripts/scripts-admin/cleanup_temps.sh ]; then
    . ./scripts/scripts-admin/cleanup_temps.sh
else
    /bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "Error" --msgbox \
"Could not find ./scripts/scripts-admin/cleanup_temps.sh" 6 70
    exit
fi

if [ -f scripts/scripts-admin/exit_message.sh ]; then
    . scripts/scripts-admin/exit_message.sh
else
    /bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "Error" --msgbox \
"Could not find ./scripts/scripts-admin/exit_message.sh" 6 70
    exit
fi

if [ -f scripts/scripts-admin/check_exit_runlevel.sh ]; then
    . scripts/scripts-admin/check_exit_runlevel.sh
else
    /bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "Error" --msgbox \
"Could not find ./scripts/scripts-admin/check_exit_runlevel.sh" 6 75
    exit
fi

