#!/bin/sh
# $Id: sastk_undo.sh,v 1.23 2002/01/01 16:26:41 zyrnix Exp $

#############################################
#
# SAStk Hardening Script Uninstall
#
# For Slackware Linux 8.0
#
#############################################
# SAStk_undo 0.1.3.0
# Copyright (C) John Jenkins
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
###########################

# Setup signal handler
handle_sigint() {
    /bin/stty intr ""
    /bin/echo -n "                 WARNING : ctrl+c pressed!"
    /bin/echo -ne " Killing SAStk                         "
    /bin/echo
    # Remove any temporary files and aliases
    if [ -d /root/.sastk_tmp ]; then
        /bin/rm -r /root/.sastk_tmp   
    fi
    /bin/stty intr ^C
    exit 1
}

trap handle_sigint 2

ver="0.1.3.0"

###############
#Check for root
###############

if [ ! "${UID}" = "0" ]; then
    /bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "Error" --msgbox \
"You must be root to run the SAStk Undo script!!\n\
Please log in or \"su -\" to root." 7 50
    exit
fi

/bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "Removal script ${ver}" --msgbox \
"\nWelcome to the SAStk removal script\n\
\nChecking System\n" 8 50

##########################
# Check for SAStk Backup #
##########################

if [ ! -d "/var/log/sastk/backup" ]; then
    /bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "Error" --msgbox \
"/var/log/sastk/backup not found!! Aborting Undo" 6 50
    exit
fi
[ ! -d "/root/.sastk_tmp" ] && /bin/mkdir -m 700 "/root/.sastk_tmp"

#################
# Check version #
#################

if [ ! -f "/etc/slackware-version" ]; then
    /bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "Error" --msgbox \
"\n/etc/slackware-version does NOT exist!!\n\
\nThis does not appear to be Slackware!\n" 8 60
    exit
fi

version=$(/usr/bin/cut -f1 -d' '  /etc/slackware-version)

if [ -z "$(echo ${version} | grep '8.0')" ];then
    /bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "Error" --msgbox \
"SAStk does not support Slackware ${version} at this time.\n\n\
Bug the developers until they include support for it." 8 60
    exit
fi

##############################
#Checking for single user mode
##############################

if [ "$(/sbin/runlevel | /usr/bin/awk '{print $2}')" != "1" ]; then
    quit=n
    while [ "${quit}" = "n" ]; do
    /bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "Telinit" --menu \
"\nSAStk removal script version ${ver}\n\
This script should be run in single user mode\n\n\
If in single user mode then press 1 to continue\n\
If not already in single user mode press 2\n" 15 70 3 \
1	"Continue in current mode" \
2	"Enter single user mode" \
Q	"Quit this script" \
2> /root/.sastk_tmp/answer

menuitem=`cat /root/.sastk_tmp/answer`
opt=$?

case $menuitem in
    1)     quit="y"
           ;;
    2)     if  [ -f /root/.bash_login ]; then
               /bin/cp "/root/.bash_login" "/root/.bash_login.bak"
           fi
           CDIR=$(/bin/pwd)
           /usr/bin/cat > /root/.bash_login << EOF
#!/bin/sh
/bin/echo
if [ "\$(/sbin/runlevel | awk '{print \$2}')" = "1" ]; then
/usr/bin/clear
quit="n"
    while [ "\${quit}" = "n" ]; do
/usr/bin/cat << !
********************************************************************************
*                     SAStk removal script version ${ver}
********************************************************************************

This is part of the SAStk removal script.
You should now be in Single user mode.
please choose an option from below.


1) Every thing seems okay.. continue with the removal
2) What the.... Stop this madness and don't let it happen again
Q) Just quit this I'll handle the rest myself

!
    /bin/echo -ne "Choose an Option: .\b"
    read choice
    case \${choice} in
        1)       quit="y"
                 cd ${CDIR}
                 ./sastk_undo.sh
                 ;;
        2)       if [ -f /root/.bash_login.bak ]; then
                 /bin/mv "/root/.bash_login.bak" "/root/.bash_login"
                 else  /bin/rm "/root/.bash_login"
                 fi
                 quit="y"
                 ;;
      Q|q)       quit="y"
                 ;;
        *)       /bin/echo -ne "Invalid choice!! \a\a"
                 ;;
     esac
   done
fi
EOF
                       /bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "Telinit" --msgbox \
"Switching to S Mode.  You will need to log back in as root.\n\
This script should continue automatically" 8 60
                       /sbin/telinit 1; exit 0
                       ;;
            Q|q)       exit 1
                       ;;
              *)       /bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "Error" --msgbox \
"Invalid choice!!\n" 6 40
                       ;;
        esac
  done
fi
 
############
# Set PATH #
############

OLDPATH="${PATH}"
PATH=/sbin:/usr/sbin:/bin:/usr/bin

##################
# Start the work #
##################

/bin/echo '#########' >> /var/log/sastk/sastk_undo.log
/bin/echo "$0 run on $(date)." >> /var/log/sastk/sastk_undo.log
/bin/echo '#########' >> /var/log/sastk/sastk_undo.log

# Replace files
for i in $(/usr/bin/find /var/log/sastk/backup -type f ! -iname "fileperm.bak" ! -iname "*.sastk"); do
    file=${i}
    newfile="/$(/bin/echo ${file} | /bin/cut -d'/' -f 6-)"
    /bin/mv ${file} ${newfile}
done
/bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "SAStk undo" --msgbox \
"\nFiles Restored"  7 40

# Remove passwd aging
/usr/bin/passwd -x 99999 -w 0 root
for user in $(/usr/bin/egrep '[1-9][0-9][0-9][0-9]' /etc/passwd | /bin/cut -d':' -f1);
do
    /usr/bin/passwd -x 99999 -w 0 "${user}" 1>> /var/log/sastk/sastk_undo.log 2>> /var/log/sastk/sastk_err.log
done
/bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "SAStk undo" --msgbox \
"\nRemoved password aging" 7 40

# Remove /bin/false from /etc/passwd
/usr/bin/sed -e '{
/ftp/s/false/bash/
/gdm/s/false/bash/
/:1:/,/:99:/s/\/bin\/false//
}' "/etc/passwd" > "/root/.sastk_tmp/passwd" 2>> /var/log/sastk/sastk_err.log
/bin/mv "/root/.sastk_tmp/passwd" "/etc/passwd" 2>> /var/log/sastk/sastk_err.log
/bin/chmod 0644 "/etc/passwd" 2>> /var/log/sastk/sastk_err.log

/bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "SAStk undo" --msgbox \
"Removed /bin/false from /etc/passwd" 6 50

# Update Lilo
[ -f /etc/lilo.conf ] && /sbin/lilo 1>> /var/log/sastk/sastk_undo.log 2>> /var/log/sastk/sastk_err.log

# Restore Original File permissions I think this should be the last thing we do.
if [ -f "/var/log/sastk/backup/fileperm.bak" ];then
    /usr/bin/awk -F: '{
        print "chmod "$1" "$4
        print "chown "$2"."$3" "$4
        system("/bin/chmod "$1" "$4)
        system("/bin/chown "$2"."$3" "$4)
    }' < "/var/log/sastk/backup/fileperm.bak" 1>> /var/log/sastk/sastk_undo.log 2>> /var/log/sastk/sastk_err.log
    /bin/rm -rf "/var/log/sastk/backup/fileperm.bak"
    /bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "SAStk undo" --msgbox \
"Restored file permissions" 6 40
fi

# Remove sastk.info file
if [ -f /usr/local/info/sastk.info ]; then
    /usr/bin/install-info --delete sastk.info "/usr/local/info/sastk.info" 2>> /var/log/sastk/sastk_err.log
fi

# Take care of .bash_login
if [ -f /root/.bash_login.bak ]; then
    /bin/mv "/root/.bash_login.bak" "/root/.bash_login"
else
    /bin/rm "/root/.bash_login" 2>> /var/log/sastk/sastk_err.log
fi

# Remove any sasrc files.
# for each in "$(/usr/bin/grep -l '/etc/rc.d/rc.paths' /etc/rc.d/rc.*)"; do
# /bin/rm "${each}" 2>> /var/log/sastk/sastk_err.log
# done 
[ -f /etc/rc.d/rc.conf ] && /bin/rm /etc/rc.d/rc.conf

export PATH="${OLDPATH}"
[ ! -d /root/.sastk_tmp ] && /bin/mkdir -m 0700 /root/.sastk_tmp

    quit=n
    while [ "${quit}" = "n" ]; do
        /bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "SAStk removal ${ver} completed" --menu \
"\nWhile it is unlikely, there is the possibility that some services
or deamons may still be running. Once you are sure that your system\n\
is working correctly you may remove the SAStk Backup and Log files with\n\
rm -rf /var/log/sastk\n" 18 75 6 \
1	"Reboot the system" \
2	"Halt the system" \
3	"Switch to Multi user Mode" \
4	"Switch to Single user Mode" \
Q	"Quit this script and stay in current mode" \
2> /root/.sastk_tmp/answer

menuitem=`cat /root/.sastk_tmp/answer`
opt=$?

        case $menuitem in
            1)   /sbin/shutdown -r now; exit 0
                 ;;
            2)   /sbin/shutdown -h now; exit 0
                 ;;
            3)   /bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "Telinit 3" --msgbox \
"Switching to Multi user Mode" 8 40
                 /sbin/telinit 3; exit 0
                 ;;
	    4)	 /sbin/telinit 1; exit 0
		 ;;
          Q|q)   quit="y"
                 ;;
            *)   /bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "Error!" --msgbox "Invalid choice!!" 8 40
                 ;;
         esac
    done

# unset anything we've exported
for i in errlog logfile BKUP LOG RC ver version ; do
    unset ${i}
done

/bin/rm -rf "/root/.sastk_tmp"
