# $Id: check_md5.sh,v 1.3 2001/07/22 02:01:26 zyrnix Exp $

# This function will be run when a user answers YES to make a change to
# a non SASrc file.
# It will compare the current md5sum with the one in LOG/filelist.md5 and warn
# the user that the file has been altered by something other than SAStk
# We will then tell the user that we are reverting to our copy of the file
# and create a backup and a unified diff with instructions on applying the
# patch or hand editing the file

check_md5() {
if [ -n "$(/usr/bin/md5sum -c /var/log/sastk/filelist.md5 2>/dev/null |/usr/bin/grep -s FAILED |/usr/bin/grep -s ${1})" ]; then
    /usr/bin/cat << EOF
               * * * * * * * ATTENTION * * * * * * *
      We have detected a change in ${1} that was not made by SAStk

 To ensure this does not affect our changes we will revert to our
 last copy of ${1} and backup the modified copy to ${1}.bkup
    We will also create a patch file called ${1}.patch
 ${0} will then continue on leaving you with the following choices:

1/ Edit the new copy of ${1} by hand to reinstate your changes

2/ Try running the patch against the new copy of ${1}
   this may not work so you should test this out on a copy first

3/ Hand edit and add the changes from the new ${1} to the .bkup
   and then mv ${1}.bkup ${1}

 Do note that editing the files after the completion of ${0}
will cause this message to appear the next time $0 is run.

                Please hit ENTER to continue

EOF
    read junk
    /usr/bin/diff -u "/var/log/sastk/backup${1}.sastk" "${1}" > "${1}.patch"
    /bin/cp -vpf "${1}" "${1}.bkup" 1>> /var/log/sastk/sastk.log 2>> /var/log/sastk/sastk_err.log
    /bin/cp -vpf "/var/log/sastk/backup${1}.sastk" "${1}" 1>> /var/log/sastk/sastk.log 2>> /var/log/sastk/sastk_err.log
fi
}
