# $Id: check_suauth.sh,v 1.5 2001/08/19 15:53:54 zyrnix Exp $

# Make a backup
if [ ! -f "/var/log/sastk/backup/etc/suauth" -a -f "/etc/suauth" ]; then
    /bin/cp -p "/etc/suauth" "/var/log/sastk/backup/etc/suauth" 2>> /var/log/sastk/sastk_err.log 
fi
if [ ! -f "/etc/suauth" -a ! -f "/var/log/sastk/backup/etc/suauth" ]; then
    /usr/bin/cat > "/var/log/sastk/backup/etc/suauth" << EOF
# /etc/suauth
# This is a Sample suauth file only
# You can modify and uncomment these lines for your own use

# Lines in this file are examined sequentially line by line and
# the first applicable line is used without examining further.

# Added by SAStk at "${CURRENT_DATE}"
       
# Examples
   
# Restrict su to root to the wheel group only
# root:ALL EXCEPT GROUP wheel:DENY

# Restrict su to root to user foo only
# root:ALL EXCEPT foo:deny
   
# Let users foo and foobar su to root using their own passwords  
# root:foo,foobar:OWNPASS
       
# Let user foo su to root with no password 
# root:foo:NOPASS

# Let user foo su to foobar using their foos own password  
# foobar:foo:OWNPASS

EOF
fi

/usr/bin/cat > "/etc/suauth" << EOF
# /etc/suauth
   
# Lines in this file are examined sequentially line by line and
# the first applicable line is used without examining further.

# Added by SAStk at "${CURRENT_DATE}" 

# Restrict su to root to the wheel group only
root:ALL EXCEPT GROUP wheel:DENY

# Examples

# Restrict su to root to user foo only
# root:ALL EXCEPT foo:deny

# Let users foo and foobar su to root using their own passwords
# root:foo,foobar:OWNPASS
   
# Let user foo su to root with no password
# root:foo:NOPASS

# Let user foo su to foobar using their foos own password
# foobar:foo:OWNPASS

EOF

/bin/echo "Restricting su to root to wheel group only" >> /var/log/sastk/sastk.log

/bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "Add wheel users?" --yesno \
"You have just enabled 'su' for only the wheel group.\n\
Would you now like to add a user to the wheel group?\n\n\
You may add users maunually with the command\n\
    usermod -G wheel username \n\n\
answer YES to add a user to the wheel group\n\
answer NO  to move to the next question\n" 13 70

# If yes, then $? = 0
quit=$?

while [ "${quit}" = "0" ]; do
    /bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "Adding user to wheel" --inputbox \
"\nPlease enter a valid user name" 10 75 2> /root/.sastk_tmp/answer
user=$(/usr/bin/cat /root/.sastk_tmp/answer)
    if [ -n "$(/usr/bin/grep "[0-9]\+" /etc/passwd |/usr/bin/grep "^${user}:")" ]; then
	if [ -n "$(/usr/bin/grep ${user} /etc/group)" ]; then
        	for group_name in "$(/usr/bin/grep ${user} /etc/group |cut -d':' -f1)"; do
        	CUR_GROUPS="$(echo ${group_name} |/usr/bin/tr ' ' ,)"
        	done
                    if [ -n "$(echo ${CUR_GROUPS} |/usr/bin/grep wheel)" ]; then
                    /bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "User exists" --msgbox \
                    "${user} is already a member of the wheel group!" 8 70
                   break 
                    fi           
        	MY_GROUPS="${CUR_GROUPS},wheel"
	else
        	MY_GROUPS="wheel"
		fi
        /usr/sbin/usermod -G "${MY_GROUPS}" "${user}" 2>> /var/log/sastk/sastk_err.log
        /bin/echo "Added ${user} to ${MY_GROUPS} " 1>> /var/log/sastk/sastk.log
        /bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "Added User" --msgbox \
"Added ${user} to the wheel group so that user can su.\n\
See /etc/group for the new addition to wheel." 8 70
        quit=1
    else
        /bin/dialog --backtitle "Slackware Security ToolKit [ http://sourceforge.net/projects/sastk ]" --title "Error!" --msgbox \
"${user} is not a valid user!!\n" 6 75
        quit=0
    fi
done
