# $Id: disable_daemons.sh,v 1.7 2001/07/22 05:26:20 zyrnix Exp $


###################
# Disable Daemons #
###################   

# This replaces the questions section previously.
display_info_daemon() {
    DAEMON=$1
    if [ -f scripts/dialogs-daemons/${DAEMON}.sh ]; then
ending="\nPress Escape to not change this value for ${DAEMON}"
        dialog --backtitle "Slackware Security ToolKit \
[ http://sourceforge.net/projects/sastk ]" --title "Enable ${DAEMON}? Currently=${VALUE}" \
--yesno "`sh scripts/dialogs-daemons/${DAEMON}.sh` \n$ending" 19 80
    answer=$?
    else
        if [ -f scripts/dialogs-daemons/uknown_service_enable.sh ]; then
dialog --backtitle "Slackware Security ToolKit \
[ http://sourceforge.net/projects/sastk ]" --title "Enable ${DAEMON}? Currently=${VALUE}" \
--yesno "`sh scripts/dialogs-daemons/unknown_service_enable.sh`" 19 80
    answer=$?
        else
dialog --backtitle "Slackware Security ToolKit \
[ http://sourceforge.net/projects/sastk ]" --title "Error!" --yesno \
"Could not find dialogs-daemons/unknown_service_enable.sh \n ${DAEMON}" 19 80
        fi
    fi
}

#
# We should disable the daemons, reboot and then install packages.
# It should be more secure this way, since there could be stray daemons
# running spawned by one of the processes we wish to disable.
#
# If we write to a status file, then on reboot the script can resume where
# it left off.
#

# Set the first argument to a more meaningful variable and see if it's
# writable.  Normally the argument will be /etc/rc.d/rc.conf.  We could ask the
# user if they want to name the file, but it will almost always be
# /etc/rc.d/rc.conf
FILE="/etc/rc.d/rc.conf"
if [ -w ${FILE} ]; then

# Display a message to the user about what this is.
dialog --backtitle "Slackware Security ToolKit \
[ http://sourceforge.net/projects/sastk ]" --title "Begin Disable Daemons" \
--msgbox "`sh scripts/dialogs-daemons/begin.sh`" 19 80

# Go through the file searching for any _enable= variables since these all
# correspond to services.
for RCCONF in $(/usr/bin/grep '^ *[A-Za-z0-9_]*_enable=' ${FILE} | /usr/bin/awk 'BEGIN { FS = "=[ \t] *|[ \t]+"} {print $1 $2}' | /bin/cut -f1 -d'#')
    do
        VARIABLE=$(/bin/echo ${RCCONF} | /bin/cut -f1 -d=)
        VALUE=$(/bin/echo ${RCCONF} | /bin/cut -f2 -d=)
        display_info_daemon ${VARIABLE}
        if [ ${answer} = 255 ]; then
            echo "test" > /dev/null 
        elif [ ${answer} = 0 ]; then
            if [ X"${VALUE}" = X"NO" ]; then
                /usr/bin/sed -e "s/${RCCONF}/${VARIABLE}=YES/" ${FILE} > ${FILE}.old;
                /bin/mv ${FILE}.old ${FILE}
                VAR_NAME=$(/bin/echo "${VARIABLE}" | /usr/bin/awk -F '_enable' '{print $1}' )
                /bin/echo "Enabling ${VAR_NAME}" >> /var/log/sastk/sastk.log
             fi
          # Because of the above until statement, we can assume this is "NO"
          else
              if [ X"${VALUE}" = X"YES" ]; then
                 /usr/bin/sed -e "s/${RCCONF}/${VARIABLE}=NO/" ${FILE} > ${FILE}.old;
                 /bin/mv ${FILE}.old ${FILE}
                 VAR_NAME=$(/bin/echo "${VARIABLE}" | /usr/bin/awk -F '_enable' '{print $1}' )
                 /bin/echo "Disabling ${VAR_NAME}" >> /var/log/sastk/sastk.log
            fi
        fi
    done
fi
