#!/bin/sh
# $Id: secure_ftpusers.sh,v 1.5 2001/10/30 12:55:38 mrgoblin Exp $

/bin/echo "Securing /etc/ftpusers"  >> /var/log/sastk/sastk.log

#Make a backup
[ ! -f "/var/log/sastk/backup/etc/ftpusers" ] && \
        /bin/cp -p /etc/ftpusers "/var/log/sastk/backup/etc/ftpusers"
[ ! -d "/root/.sastk_tmp" ] && /bin/mkdir -m 0700 /root/.sastk_tmp

# Get current users
/bin/grep -v "\#" /etc/ftpusers > "/root/.sastk_tmp/ftpusers_tmp"

# Get system accounts
/usr/bin/awk -F: '{ if ( $3 <= 999 )
                  { print $1 } 
}' /etc/passwd >> "/root/.sastk_tmp/ftpusers_tmp"

# Add and sort
/bin/cat "/root/.sastk_tmp/ftpusers_tmp" |  sort | uniq > /root/.sastk_tmp/ftpusers \
                                   2>> /var/log/sastk/sastk_err.log

# Add the header

/usr/bin/sed -e '1 {
i\
#\
# ftpusers      This file describes the names of the users that may\
#               _*NOT*_ log into the system via the FTP server.\
#               This usually includes "root", "uucp", "news" and the\
#               like, because those users have too much power to be\
#               allowed to do "just" FTP...\
#\
#\
# Version:      @(#)/etc/ftpusers       3.00    02/25/2001 volkerdi\
#\
# Original Author:  Fred N. van Kempen, <waltje@uwalt.nl.mugnet.org>\
#\
# The entire line gets matched, so no comments or extra characters on\
# lines containing a username.\
#\
# To enable anonymous FTP, remove the "ftp" user:
}' /root/.sastk_tmp/ftpusers > /etc/ftpusers

# Add the footer
/bin/echo -e "\n# End of ftpusers." >> /etc/ftpusers

update_md5 "/etc/ftpusers"
