#!/bin/sh
#
# $Id: security-monthly.sh,v 1.6 2001/12/16 23:51:19 dentonj Exp $
#
######################################
#
# Seccheck for Slackware Linux
#
# The program was modified for SAStk by Jeffrey Denton <dentonj@sastk.org>.  
# It was originally written by Marc Heuse <marc@suse.de> for SuSE.  
#
######################################

####
#
# SuSE monthly security check v2.0 by Marc Heuse <marc@suse.de>
#
####

umask 077
PATH="/sbin:/usr/sbin:/bin:/usr/bin"
SEC_BIN="/usr/local/sbin/seccheck"
SEC_VAR="/var/log/sastk/seccheck"
SEC_DATA="$SEC_VAR/data"
OLD1="$SEC_VAR/security-report-daily"
OLD2="$SEC_VAR/security-report-weekly"
OLD3="$SEC_VAR/security-report-monthly"

if [ ! -d "$SEC_VAR" ]; then
    /bin/mkdir "$SEC_VAR" || exit 1
fi
if [ ! -d "$SEC_DATA" ]; then
    /bin/mkdir "$SEC_DATA" || exit 1
fi
for i in "$OLD1" "$OLD2" "$OLD3" ; do
    if [ "$i" != "" ]; then
        if [ ! -e "$i" ]; then
    	    /bin/touch "$i"
        fi
    fi
done
for i in "$SEC_DATA/sbit" "$SEC_DATA/write" "$SEC_DATA/devices" "$SEC_DATA/write-bin" "$SEC_DATA/nouser" ; do
    if [ ! -e "$i" ] ; then
        /bin/touch "$i"
    fi
done

echo -e '\nNOTE: Have you checked http://www.slackware.com for security updates?!\n'

/usr/bin/cat "$OLD1"

####
# Commented until SAStk installs John.
#
#if [ -x /usr/sbin/john -a -x /usr/sbin/unshadow ]; then
#    echo -e '\nComplete list of user accounts with guessable passwords:'
#    unshadow /etc/passwd /etc/shadow > $SEC_VAR/passwd
#    john -show "$SEC_VAR/passwd" | sed -n 's/:.*//p'
#    /bin/rm -f $SEC_VAR/passwd
#fi
####

/bin/echo -e '\nComplete list of unused user accounts which have a password assigned:'
$SEC_BIN/checkneverlogin

/bin/echo -e '\nComplete list of writeable and executeable programs:'
/usr/bin/cat "$SEC_DATA/write-bin"

/bin/echo -e '\nComplete list of suid/sgid files:'
/usr/bin/cat "$SEC_DATA/sbit"

/bin/echo -e '\nComplete list of world writeable files:'
/usr/bin/cat "$SEC_DATA/write"

/bin/echo -e '\nComplete list of unowned files:'
/usr/bin/cat "$SEC_DATA/nouser"

/bin/echo -e '\nComplete list of (char/block) devices:'
/usr/bin/cat "$SEC_DATA/devices"

exit 0
